import {Returns} from './helpers.js'

// Order matters here, because these items will merged into a new
// dispatcher in the order they are listed

const typeObject = {}

export const types = () => typeObject

export class Type {
   constructor(f) {
      this.test = f
   }
}

export const Undefined = new Type(t => typeof t === 'undefined')
export const TypeOfTypes = new Type(t => t instanceof Type)

export const typeOf = Returns(TypeOfTypes, item => {
   for (const type of Object.values(typeObject)) {
      if (!(type instanceof Type)) continue
      if (type.test(item)) return type
   }
})

// bootstrapping order matters, but order of exports in a module isn't
// simply the order that the items are listed in the module. So we make
// an explicitly ordered export of implementations for this sake:

export const bootstrapTypes = {
   types, Type, Undefined, TypeOfTypes, typeOf
}
